Attribute VB_Name = "ModGraph"
'Declairations
Dim GraphWidth As Integer

'Customisable
Public Const GraphStart As Integer = 200  'Back lining start (X)
'-->
' --------
'       | | < 3D end
' --------

Public Const Graph3DTop As Integer = 200 'Top back lining start (Y)
'-->
'--------
'        \ < 3D top
' --------
'         |
' --------

'Not customisable
Public Const Graph3DAddWidth As Integer = 30
Public Const Graph3DReduceWidth As Integer = 10

'Picture graph information
Public Const GraphMax As Integer = 4730
Public Const GraphMaxHeight As Integer = 1240
Public Const GraphTopMinimum As Integer = 320

'Draw lines for 3D box
Public Function DrawGraphLines(PicObject As Object, GraphTop As Integer, GraphLineWidth As Integer, GraphTopHeight As Integer)
    
    GraphWidth = GraphStart + GraphLineWidth
    
    PicObject.Line (GraphWidth - GraphStart, GraphTop)-(GraphWidth, GraphTop - Graph3DTop)
    PicObject.Line (GraphWidth - GraphStart, GraphTop + GraphTopHeight + Graph3DTop)-(GraphWidth, GraphTop + GraphTopHeight)
    PicObject.Line (GraphWidth - GraphStart, GraphTop)-(GraphWidth - GraphStart, GraphTop + GraphTopHeight + Graph3DTop)
    PicObject.Line (GraphWidth - Graph3DReduceWidth, GraphTop - Graph3DTop)-(GraphWidth - Graph3DReduceWidth, GraphTop + GraphTopHeight + Graph3DAddWidth)
    
    PicObject.Line (1, GraphTop)-(GraphStart, GraphTop - Graph3DTop)
    PicObject.Line (Graph3DAddWidth - Graph3DReduceWidth, GraphTop)-(Graph3DAddWidth - Graph3DReduceWidth, GraphTop + GraphTopHeight + Graph3DTop)
        
    PicObject.Line (1, GraphTop)-(GraphWidth - GraphStart, GraphTop)
    PicObject.Line (1, GraphTop + GraphTopHeight + Graph3DTop)-(GraphWidth - GraphStart, GraphTop + GraphTopHeight + Graph3DTop)
    PicObject.Line (GraphStart, GraphTop - Graph3DTop)-(GraphWidth, GraphTop - Graph3DTop)
    
End Function

'Sets up functions that needs to be set
Public Function DrawGraph(PicObject As Object, GraphTop3D As Integer, GraphWidth3D As Integer, GraphHeight3D As Integer, Lined As Boolean, TypeNumber As Integer)
    
    If TypeNumber = 0 Then
        'Draw side of box
        If DrawGradient(PicObject, 0, GraphTop3D, GraphWidth3D, GraphHeight3D, 0, 763, 200, 220, 255, 0, 0, 0) = False Then
            'Do nothing
        End If
        
        'Draw top of box
        If DrawGradient(PicObject, 1, GraphTop3D, GraphWidth3D, GraphHeight3D, 0, 763, 0, 0, 0, 200, 220, 255) = False Then
            'Do nothing
        End If
        
        'Draw end of box
        If DrawGradient(PicObject, 2, GraphTop3D, GraphWidth3D, GraphHeight3D, 0, 763, 0, 0, 0, 200, 220, 255) = False Then
            'Do nothing
        End If
            
        'Draw graph outer lines
        If Lined = True Then DrawGraphLines PicObject, GraphTop3D, GraphWidth3D, GraphHeight3D
    ElseIf TypeNumber = 1 Then
                'Draw side of box
        If DrawGradient(PicObject, 0, GraphTop3D, GraphWidth3D, GraphHeight3D, 0, 763, 255, 0, 0, 255, 255, 255) = False Then
            'Do nothing
        End If
        
        'Draw top of box
        If DrawGradient(PicObject, 1, GraphTop3D, GraphWidth3D, GraphHeight3D, 0, 763, 255, 255, 255, 255, 0, 0) = False Then
            'Do nothing
        End If
        
        'Draw end of box
        If DrawGradient(PicObject, 2, GraphTop3D, GraphWidth3D, GraphHeight3D, 0, 763, 255, 255, 255, 255, 0, 0) = False Then
            'Do nothing
        End If
            
        'Draw graph outer lines
        If Lined = True Then DrawGraphLines PicObject, GraphTop3D, GraphWidth3D, GraphHeight3D
    End If
    
End Function

'Draws the gradient, which is then set to the object (PicObject)
Public Function DrawGradient(PicObject As Object, SideDraw As Integer, WriteTop As Integer, WriteWidth As Integer, WriteHeight As Integer, St%, h%, Red1%, Green1%, Blue1%, Red2%, Green2%, Blue2%) As Boolean
    
    On Error GoTo FinaliseError
    
    Dim H2%, H3%, IvR%, IvG%, IvB%
    Dim VR, VG, VB As Single
    Dim Color1, Color2 As Long
    Dim r, g, b, r2, g2, b2 As Integer
    Dim temp As Long
    
    Color1 = RGB(Red1, Green1, Blue1)
    Color2 = RGB(Red2, Green2, Blue2)
    temp = (Color1 And 255): r = temp And 255
    temp = Int(Color1 / 256): g = temp And 255
    temp = Int(Color1 / 65536): b = temp And 255
    temp = (Color2 And 255): r2 = temp And 255
    temp = Int(Color2 / 256): g2 = temp And 255
    temp = Int(Color2 / 65536): b2 = temp And 255
        
    VR = Abs(r - r2) / WriteWidth
    VG = Abs(g - g2) / WriteWidth
    VB = Abs(b - b2) / WriteWidth
    
    If r2 < r Then VR = -VR
    If g2 < g Then VG = -VG
    If b2 < b Then VB = -VB
    
    Dim GraphOccurance As Integer
    GraphWidth = GraphStart + WriteWidth
    GraphTopHeight = WriteHeight
    GraphTop = WriteTop
    
    GraphOccurance = GraphWidth
    
    Dim NextPosition As Integer
    NextPosition = 0
    
    If SideDraw = 2 Then GoTo DrawGraphEnd
    GraphWidth = GraphStart
    
    Do
        GraphWidth = GraphWidth + 15
        NextPosition = NextPosition + 15
        r2 = r + VR * NextPosition: g2 = g + VG * NextPosition: b2 = b + VB * NextPosition
        If SideDraw = 0 Then
            PicObject.Line (GraphWidth - GraphStart, GraphTop)-(GraphWidth, GraphTop - Graph3DTop), RGB(r2, g2, b2)
        ElseIf SideDraw = 1 Then
            PicObject.Line (GraphWidth - GraphStart, GraphTop)-(GraphWidth - GraphStart, GraphTop + GraphTopHeight + Graph3DTop), RGB(r2, g2, b2)
        End If
    Loop Until NextPosition >= GraphOccurance - GraphStart

FinaliseError:
    DrawGradient = True
    Exit Function
    
DrawGraphEnd:

    Do
        NextPosition = NextPosition + 15
        PicObject.Line (GraphWidth - GraphStart, GraphTop + NextPosition)-(GraphWidth, GraphTop - Graph3DTop + NextPosition), RGB(r2, g2, b2)
    Loop Until NextPosition >= GraphTopHeight + Graph3DTop
    DrawGradient = True
    
End Function
