Attribute VB_Name = "ModOpen"
Public Function CommandOpen()

    On Error GoTo FinaliseError

    FrmMain.Dlg.flags = &H1000 + &H4 + &H8 + &H800
    FrmMain.Dlg.DialogTitle = "Open a WinPak Archive"
    FrmMain.Dlg.Filter = "WinPak's (*.wpk)|*.wpk|All files (*.*)|*.*"
    FrmMain.Dlg.DefaultExt = ""
    FrmMain.Dlg.ShowOpen
    
    If FrmMain.Dlg.Filename = "" Then Exit Function
    
    If WinPakOpen(FrmMain.Dlg.Filename, FrmMain.ListFiles) = True Then
        ArchiveName = FrmMain.Dlg.Filename
        AddToRecent FrmMain.Dlg.Filename
        OpenFile
        OpenFileFeature
        If WinPakComment(ArchiveName) <> "" Then
            If CommentPopup = True Then
                CommandShowComment
            End If
        End If
    Else
        MessageBox "WinCrypt was unable to open the WinPak archive specified.", OKOnly, Critical
        CloseFile
        CloseFileFeature
    End If
    
    Exit Function
    
FinaliseError:
 
    If Err <> 32755 Then
        MessageBox "An unknown error occured!", OKOnly, Critical
        Unload FrmMain
    End If

End Function

Function WinPakOpen(WinPak As String, FileList As ListView) As Boolean
    Select Case File_Method
        Case 0:
            WinPakOpen = WPK_Open(WinPak, FileList)
    End Select
End Function

Function WPK_Open(WinPak As String, FileList As ListView) As Boolean
    
    On Error GoTo FinaliseError
    
    Dim FileNumber As Integer
    Dim Offset As Long
    Dim Size As Long
    Dim Name As String
    Dim DirPath As String
    
    FolderString = ""
    
    STBarTitle = "Choose ""New"" to create or ""Open"" to open an archive"
    FileList.ListItems.Clear
    
    LightsOff01
    
    If WinPakValid(WinPak) = True Then
        If WinPakComment(WinPak) <> "" Then EnableComment Else DisableComment
        FileNumber = FreeFile
        Open WinPak For Binary As FileNumber
            Get FileNumber, Len(MainHeader) + 1, FileListStart
            If FileListStart = 0 Then
                If LOF(FileNumber) = 2 + Len(MainHeader) Then
                    WPK_Open = True
                    ArchiveName = WinPak
                    STBarTitle = "WinCrypt - " & GetFileName(ArchiveName)
                    GoTo FinaliseError
                End If
            Else
                If FileListStart = 0 Then FileListStart = 1
                Do
                    Get FileNumber, FileListStart, Offset
                    FileListStart = FileListStart + 4
                    
                    Get FileNumber, FileListStart, Size
                    FileListStart = FileListStart + 4
                    
                    DirPath = String$(65536, Chr$(0))
                    Get FileNumber, FileListStart, DirPath 'Length posible
                    DirPath = Mid(DirPath, 1, InStr(1, DirPath, Chr$(0)) - 1)
                    FileListStart = FileListStart + Len(DirPath) + 1
                    
                    Name = String$(256, Chr$(0))
                    Get FileNumber, FileListStart, Name 'Length posible
                    Name = Mid(Name, 1, InStr(1, Name, Chr$(0)) - 1)
                    FileListStart = FileListStart + 257
                    
                    If Name = "" Or Offset = 0 Or Size = 0 Then
                        If LOF(FileNumber) = 2 + Len(MainHeader) And FileListStart = 257 + 9 Then
                            WPK_Open = True
                            ArchiveName = WinPak
                            STBarTitle = "WinCrypt - " & GetFileName(ArchiveName)
                        End If
                        GoTo FinaliseError
                    End If

                    If DirPath <> MainDataClassHeader Then
                        FoldersString = FoldersString & DirPath & Name & " (" & FormatKB(Size) & ")" & SetSep
                        Set LF = FileList.ListItems.Add(, , Name)

                        If InStr(1, Name, ".") <> 0 Then
                            For M = 1 To Len(Name)
                                GetChr0 = Right(Name, M)
                                GetChr1 = Left(GetChr0, 1)
                                If GetChr1 = "." Then
                                    Set LFS = LF.ListSubItems.Add(, , GetFileType(Right(GetChr0, M - 1)))
                                    Exit For
                                End If
                            Next M
                        Else
                            Set LFS = LF.ListSubItems.Add(, , "Unknown type")
                        End If
                        Set LFS = LF.ListSubItems.Add(, , Size & " Bytes - " & FormatKB(Size))
                        Set LFS = LF.ListSubItems.Add(, , Offset)
                        Set LFS = LF.ListSubItems.Add(, , DirPath)
                    End If
                Loop Until FileListStart > LOF(FileNumber)
            End If
            WPK_Open = True
            If AutoSize = True Then Call ModListView.AutoSizeColumnWidth(FrmMain.ListFiles)
            If AutoFit = True Then Call ModListView.AutoFitColumnWidth(FrmMain.ListFiles)
            ArchiveName = WinPak
            STBarTitle = "WinCrypt - " & GetFileName(ArchiveName)
            ResizeToFit
    Else
        STBarTitle = "Choose ""New"" to create or ""Open"" to open an archive"
        LightsOff00
    End If
FinaliseError:
    SetPanelCaption "", True
    Close FileNumber
End Function
